/* Tabela CONSSERV: Consumo Por Servio                                                                    */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela CONSSERV      */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Consumo Por Servio,                   */
/*             utilizando a tabela Geral de Logs de Operaes                                              */
/* Criao:                                                                                                */
/* 03/05/2007 - Leandro Rodrigo                                                                            */


IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'LOG_PLA_CONSSERV'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER LOG_PLA_CONSSERV
GO

CREATE TRIGGER LOG_PLA_CONSSERV
ON CONSSERV 
AFTER DELETE, INSERT, UPDATE 
AS
BEGIN

DECLARE @V_USUARIO   VARCHAR(40);
DECLARE @V_TIPO      VARCHAR(1);
DECLARE @V_ITPESQ    VARCHAR(40);
DECLARE @V_DESC      VARCHAR(500);
DECLARE @V_DTOPER    DATETIME;
DECLARE @V_DSDIASEM  VARCHAR(3);
DECLARE @V_CDARVPROD VARCHAR(20);


/* Variveis do cursor */
DECLARE @V_IDCOMANDO           VARCHAR(1);
DECLARE @V_NEW_CDFILIAL        VARCHAR(4);
DECLARE @V_NEW_CDSERVFILI      VARCHAR(5);
DECLARE @V_NEW_IDQTDECONS      VARCHAR(1);
DECLARE @V_NEW_IDTIPOCONS      VARCHAR(1);
DECLARE @V_NEW_DTCONSSERV      DATETIME;
DECLARE @V_NEW_CDPRODUTO       VARCHAR(12);
DECLARE @V_NEW_QTCONSSERV      smallint;
DECLARE @V_OLD_CDFILIAL        VARCHAR(4);
DECLARE @V_OLD_CDSERVFILI      VARCHAR(5);
DECLARE @V_OLD_IDQTDECONS      VARCHAR(1);
DECLARE @V_OLD_IDTIPOCONS      VARCHAR(1);
DECLARE @V_OLD_DTCONSSERV      DATETIME;
DECLARE @V_OLD_CDPRODUTO       VARCHAR(12);
DECLARE @V_OLD_QTCONSSERV      smallint;

   SET @V_TIPO = '0';
   SET @V_DESC = '';
   SET @V_DSDIASEM = '';
   SET @V_CDARVPROD = '';

   DECLARE C_DADOS CURSOR FOR
     SELECT
       'D' IDCOMANDO,
       NULL, NULL, NULL, NULL,
       NULL, NULL, NULL,
       CDFILIAL,
       CDSERVFILI,
       IDQTDECONS,
       IDTIPOCONS,
       DTCONSSERV,
       CDPRODUTO,
       QTCONSSERV
     FROM
       DELETED
     WHERE
       0 = (SELECT COUNT(*) FROM INSERTED)

     UNION ALL

     SELECT
       'U' IDCOMANDO,
       INSERTED.CDFILIAL,
       INSERTED.CDSERVFILI,
       INSERTED.IDQTDECONS,
       INSERTED.IDTIPOCONS,
       INSERTED.DTCONSSERV,
       INSERTED.CDPRODUTO,
       INSERTED.QTCONSSERV,
       DELETED.CDFILIAL,
       DELETED.CDSERVFILI,
       DELETED.IDQTDECONS,
       DELETED.IDTIPOCONS,
       DELETED.DTCONSSERV,
       DELETED.CDPRODUTO,
       DELETED.QTCONSSERV
     FROM
       INSERTED,
       DELETED
     WHERE
       INSERTED.CDFILIAL    =  DELETED.CDFILIAL    AND
       INSERTED.CDSERVFILI  =  DELETED.CDSERVFILI 

     UNION ALL

     SELECT
       'I' IDCOMANDO,
       CDFILIAL,
       CDSERVFILI,
       IDQTDECONS,
       IDTIPOCONS,
       DTCONSSERV,
       CDPRODUTO,
       QTCONSSERV,
       NULL, NULL, NULL, NULL, 
       NULL, NULL, NULL
     FROM
       INSERTED
     WHERE
       0 = (SELECT COUNT(*) FROM DELETED);

   OPEN C_DADOS;
   FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                                @V_NEW_CDFILIAL,
                                @V_NEW_CDSERVFILI,
                                @V_NEW_IDQTDECONS,
                                @V_NEW_IDTIPOCONS,
                                @V_NEW_DTCONSSERV,
                                @V_NEW_CDPRODUTO,
                                @V_NEW_QTCONSSERV,
                                @V_OLD_CDFILIAL,
                                @V_OLD_CDSERVFILI, 
                                @V_OLD_IDQTDECONS,
                                @V_OLD_IDTIPOCONS,
                                @V_OLD_DTCONSSERV,
                                @V_OLD_CDPRODUTO,
                                @V_OLD_QTCONSSERV; 

   WHILE (@@FETCH_STATUS = 0) BEGIN

      IF @V_IDCOMANDO = 'D' /* Deleting */ BEGIN
         IF @V_OLD_CDFILIAL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Filial=' + @V_OLD_CDFILIAL;
         END;
         IF @V_OLD_CDSERVFILI IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Serv=' + @V_OLD_CDSERVFILI;
         END;
         IF @V_OLD_IDQTDECONS IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Tipo=' + @V_OLD_IDQTDECONS;
         END;
         IF @V_OLD_DTCONSSERV IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DtValid=' + CONVERT(VARCHAR, @V_OLD_DTCONSSERV);
         END;
         IF @V_OLD_IDTIPOCONS IS NOT NULL BEGIN
            IF @V_OLD_IDTIPOCONS = '1' BEGIN SET @V_DSDIASEM = 'Dom'; END;
            IF @V_OLD_IDTIPOCONS = '2' BEGIN SET @V_DSDIASEM = 'Seg'; END;
            IF @V_OLD_IDTIPOCONS = '3' BEGIN SET @V_DSDIASEM = 'Ter'; END;
            IF @V_OLD_IDTIPOCONS = '4' BEGIN SET @V_DSDIASEM = 'Qua'; END;
            IF @V_OLD_IDTIPOCONS = '5' BEGIN SET @V_DSDIASEM = 'Qui'; END;
            IF @V_OLD_IDTIPOCONS = '6' BEGIN SET @V_DSDIASEM = 'Sex'; END;
            IF @V_OLD_IDTIPOCONS = '7' BEGIN SET @V_DSDIASEM = 'Sb'; END;
            IF @V_OLD_IDTIPOCONS = '8' BEGIN SET @V_DSDIASEM = 'Fer'; END;
            IF @V_OLD_IDTIPOCONS = '9' BEGIN SET @V_DSDIASEM = 'Exc'; END;

         SET @V_DESC = @V_DESC + ' Dia=' + @V_DSDIASEM;
         END;
         IF @V_OLD_CDPRODUTO IS NOT NULL BEGIN
            SELECT @V_CDARVPROD = CDARVPROD FROM PRODUTO WHERE CDPRODUTO = @V_OLD_CDPRODUTO;
            SET @V_DESC = @V_DESC + ' Prod=' + @V_CDARVPROD;
         END;
         IF @V_OLD_QTCONSSERV IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Qtde=' + CONVERT(VARCHAR, @V_OLD_QTCONSSERV);
         END;
         SET @V_TIPO = '3';
         SET @V_ITPESQ = @V_OLD_CDFILIAL+@V_OLD_CDSERVFILI+@V_OLD_IDQTDECONS+@V_OLD_IDTIPOCONS+CONVERT(VARCHAR, @V_OLD_DTCONSSERV, 112)+@V_CDARVPROD;
      END ELSE BEGIN
         IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
            IF (@V_OLD_CDFILIAL   <> @V_NEW_CDFILIAL)   OR
               (@V_OLD_CDSERVFILI <> @V_NEW_CDSERVFILI) OR
               (@V_OLD_IDQTDECONS <> @V_NEW_IDQTDECONS) OR
               (@V_OLD_IDTIPOCONS <> @V_NEW_IDTIPOCONS) OR
               (@V_OLD_DTCONSSERV <> @V_NEW_DTCONSSERV) OR
               (@V_OLD_CDPRODUTO  <> @V_NEW_CDPRODUTO)  OR
               (@V_OLD_QTCONSSERV <> @V_NEW_QTCONSSERV) BEGIN

               SET @V_TIPO  = '2';
               SELECT @V_CDARVPROD = CDARVPROD FROM PRODUTO WHERE CDPRODUTO = @V_OLD_CDPRODUTO;
               SET @V_ITPESQ = @V_OLD_CDFILIAL+@V_OLD_CDSERVFILI+@V_OLD_IDQTDECONS+@V_OLD_IDTIPOCONS+CONVERT(VARCHAR, @V_OLD_DTCONSSERV, 112)+@V_CDARVPROD;
            END;
         END ELSE BEGIN
            SET @V_TIPO   = '1';
            SELECT @V_CDARVPROD = CDARVPROD FROM PRODUTO WHERE CDPRODUTO = @V_NEW_CDPRODUTO;
            SET @V_ITPESQ = @V_NEW_CDFILIAL+@V_NEW_CDSERVFILI+@V_NEW_IDQTDECONS+@V_NEW_IDTIPOCONS+CONVERT(VARCHAR, @V_NEW_DTCONSSERV, 112)+@V_CDARVPROD;
         END;

         IF @V_NEW_CDFILIAL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Filial=' + @V_NEW_CDFILIAL;
         END;
         IF @V_NEW_CDSERVFILI IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Serv=' + @V_NEW_CDSERVFILI;
         END;
         IF @V_NEW_IDQTDECONS IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Tipo=' + @V_NEW_IDQTDECONS;
         END;
         IF @V_NEW_DTCONSSERV IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' DtValid=' + CONVERT(VARCHAR, @V_NEW_DTCONSSERV);
         END;
         IF @V_NEW_IDTIPOCONS IS NOT NULL BEGIN
            IF @V_NEW_IDTIPOCONS = '1' BEGIN SET @V_DSDIASEM = 'Dom'; END;
            IF @V_NEW_IDTIPOCONS = '2' BEGIN SET @V_DSDIASEM = 'Seg'; END;
            IF @V_NEW_IDTIPOCONS = '3' BEGIN SET @V_DSDIASEM = 'Ter'; END;
            IF @V_NEW_IDTIPOCONS = '4' BEGIN SET @V_DSDIASEM = 'Qua'; END;
            IF @V_NEW_IDTIPOCONS = '5' BEGIN SET @V_DSDIASEM = 'Qui'; END;
            IF @V_NEW_IDTIPOCONS = '6' BEGIN SET @V_DSDIASEM = 'Sex'; END;
            IF @V_NEW_IDTIPOCONS = '7' BEGIN SET @V_DSDIASEM = 'Sb'; END;
            IF @V_NEW_IDTIPOCONS = '8' BEGIN SET @V_DSDIASEM = 'Fer'; END;
            IF @V_NEW_IDTIPOCONS = '9' BEGIN SET @V_DSDIASEM = 'Exc'; END;
  
            SET @V_DESC = @V_DESC + ' Dia=' + @V_DSDIASEM;
         END;
         IF @V_NEW_CDPRODUTO IS NOT NULL BEGIN
            SELECT @V_CDARVPROD = CDARVPROD FROM PRODUTO WHERE CDPRODUTO = @V_NEW_CDPRODUTO;
            SET @V_DESC = @V_DESC + ' Prod=' + @V_CDARVPROD;
         END;
         IF @V_NEW_QTCONSSERV IS NOT NULL BEGIN
            IF @V_IDCOMANDO = 'U' /* Updating */ BEGIN
               SET @V_DESC = @V_DESC + ' Qtde.de=' + CONVERT(VARCHAR, @V_OLD_QTCONSSERV) + ' para=' + CONVERT(VARCHAR,@V_NEW_QTCONSSERV);
            END ELSE BEGIN
               SET @V_DESC = @V_DESC + ' Qtde=' + CONVERT(VARCHAR, @V_NEW_QTCONSSERV);
            END;
         END;
      END;

      IF @V_TIPO <> '0' BEGIN
         SELECT @V_USUARIO = MAX(NMOPERADOR) 
         FROM SQLWEBTUNNING SQ, OPERADOR OP
         WHERE
         SQ.DSREMOTEOPER = OP.CDOPERADOR AND
         SQ.NRAUDSID     = @@SPID;    
 
         SET @V_USUARIO = ISNULL(@V_USUARIO, '');         
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();
  
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('CONSSERV',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO,      @V_ITPESQ, SUBSTRING(@V_DESC, 1, 300));
            END;
         END;
      END;

      FETCH NEXT FROM C_DADOS INTO @V_IDCOMANDO,
                                   @V_NEW_CDFILIAL,
                                   @V_NEW_CDSERVFILI,
                                   @V_NEW_IDQTDECONS,
                                   @V_NEW_IDTIPOCONS,
                                   @V_NEW_DTCONSSERV,
                                   @V_NEW_CDPRODUTO,
                                   @V_NEW_QTCONSSERV,
                                   @V_OLD_CDFILIAL,
                                   @V_OLD_CDSERVFILI, 
                                   @V_OLD_IDQTDECONS,
                                   @V_OLD_IDTIPOCONS,
                                   @V_OLD_DTCONSSERV,
                                   @V_OLD_CDPRODUTO,
                                   @V_OLD_QTCONSSERV; 
   END;
   CLOSE      C_DADOS;
   DEALLOCATE C_DADOS;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_PLA_CALENCARD','4.11.113';
GO
